; ARG.ASM
; part of Ben's Command Extender
; command line handling procs
; 5 Dec 97
; 9 Dec 97 added quoted arguments to nextarg
; blm
;



; nextarg
; copy the next command line argument to string at ax
nextarg:
	push    ax
	push    bx
	push    cx
	push    dx
	push    si
	push    di
	push    ds
	push    es
	
	push    cs
	pop     es
	mov     di, ax

	cmp     word[cs:done_flag], TRUE
	je      .bail_out

	mov     ax, [cs:command_seg]
	mov     ds, ax
	mov     si, [cs:command_tail]
	add     word si, [cs:char_count]
	
	cld
	xor     cx, cx

.ltrim:
	lodsb
	inc     cx
	cmp     al, TAB
	je      .ltrim
	cmp     al, SPACE
	je      .ltrim
	cmp     al, CR
	je      .cr_found
	dec     si

.nextchar:
	lodsb
	inc     cx
	cmp     al, CR
	je      .cr_found
	cmp     al, QT
	jne     .not_qt
	inc     word [cs:in_quote]
	cmp     word [cs:in_quote], 2
	jge     .done
	jmp     .nextchar
.not_qt:
	cmp     word [cs:in_quote], 1
	jge     .in_qt
	cmp     al, TAB
	je      .done
	cmp     al, SPACE
	je      .done
.in_qt:
	stosb
	jmp .nextchar

.cr_found:
	mov     word [cs:done_flag], TRUE
.done:
	dec     cx
	mov     word [cs:in_quote], 0
	add     word [cs:char_count], cx
.bail_out:  
	xor     al, al
	stosb
	
	pop     es
	pop     ds
	pop     di
	pop     si
	pop     dx
	pop     cx
	pop     bx
	pop     ax
	ret
	
	
	
; commands
; copy entire command tail to string at ax
; skips arg0
commands:
	push    ax
	push    si
	push    di
	push    ds
	push    es
	
	push    cs
	pop     es
	mov     di, string

	mov     ax, [cs:command_seg]
	mov     ds, ax
	mov     si, [cs:command_tail]
	
	cld
.ltrim:
	lodsb
	cmp     al, TAB
	je      .ltrim
	cmp     al, SPACE
	je      .ltrim
	cmp     al, CR
	je      .done
	dec     si
	
.skip_arg0:
	lodsb
	cmp     al, TAB
	je      .nextchar
	cmp     al, SPACE
	je      .nextchar
	cmp     al, CR
	je      .done
	jmp     .skip_arg0
	
.nextchar:
	lodsb
	cmp     al, CR
	je      .done
	stosb
	jmp .nextchar
	
.done:
	xor     al, al
	stosb   
	
	pop     es
	pop     ds
	pop     di
	pop     si
	pop     ax
	ret
	
	
	
; arg_init
; called before any BCE.COM command is executed
; init all data used by nextarg and commands
; should be called immediatly after the systems
; makes an execute request
arg_init:
	push    bx
	mov     word [cs:done_flag], FALSE
	mov     word [cs:in_quote], FALSE
	mov     word [cs:char_count], 00h
	add     bx, 2
	mov     word [cs:command_tail], bx
	mov     bx, ds
	mov     word [cs:command_seg], bx
	pop     bx
	ret
	
	
	
; arg data
char_count      dw 0000h            ; count of characters
command_tail    dw 0000h            ; near pointer to command tail
command_seg     dw 0000h
done_flag       dw FALSE            ; set when cr is reached
in_quote        dw 0000h            ; set when between quotation marks



