; RAND.ASM
; part of Ben's Command Extender
; random number procs
; 5 Dec 97
; blm
;

; the best little rnd function in Texas
; returns random number in ax
rnd:
	push    bx
	push    cx
	
	mov     ax,[cs:seed_value]
	and     ax,ax
	jnz     .begin
	call    seed

.begin:
	mov     cx,10h
.nextbit:
	mov     bx,ax
	and     bx,2Dh      
	xor     bh,bl       
	clc
	jpe     .even        
	stc                 
.even:
	rcr     ax,01h
	loop    .nextbit     
	mov     [cs:seed_value],ax    
	
	pop     cx
	pop     bx
	ret
	
	
	
; rand
; print sixteen bit random number between 0 and 65535
rand:
	call    rnd
	call    [cs:show_num]
	call    [cs:new_line]
	ret
	
	
	
; randm
; print sixteen bit random number between 1 and arg1
randm:
	xor     dx, dx
	mov		ax, string
	call    nextarg     ; skip arg0
	mov		ax, string
	call    nextarg
	mov		ax, string
	call    atou
	and     ax, ax
	jz      .divzero
	mov     bx, ax
	call    rnd
	div     bx
	inc     dx
.divzero:
	mov     ax, dx
	call    [cs:show_num]
	call    [cs:new_line]
	ret
	
	
	
; randr
; print sixteen bit random number between arg1 and arg2
randr:
	push    bx
	push    cx
	push    dx

	xor     dx, dx
	mov		ax, string
	call    nextarg     ; skip arg0
	mov		ax, string
	call    nextarg     ; get lower limit
	mov		ax, string
	call    atou
	mov     cx, ax

	mov		ax, string
	call    nextarg     ; get upper limit
	mov		ax, string
	call    atou
	and     ax, ax
	jz      .done
	mov     bx, ax
	call    rnd
	div     bx
	inc     dx
	cmp     dx, cx
	jae     .done
	mov     dx, cx
.done:
	mov     ax, dx
	call    [cs:show_num]
	call    [cs:new_line]
	
	pop     dx
	pop     cx
	pop     bx
	ret
	
	
	
; seed
; a good seed for rand functions
; returns seed in ax
seed:
	cli                     
	xor     al, al          
	out     43h,al          
	in      al,40h          
	mov     ah,al           
	in      al,40h          
	sti                     
	and     ax,ax           
	jnz     .notzero        
	inc     ax              
.notzero:
	ret



; rand data
seed_value      dw 0000h
